<div id="order" class="page-layout carded fullwidth" fusePerfectScrollbar>

    <!-- TOP BACKGROUND -->
    <div class="top-bg {{secondColorBrand}}"></div>
    <!-- / TOP BACKGROUND -->

    <!-- CENTER -->
    <div class="center">

        <!-- HEADER -->
        <div class="header white-fg"
             fxLayout="row" fxLayoutAlign="space-between center">

            <!-- APP TITLE -->
            <div fxLayout="row" fxLayoutAlign="start center">

                <button class="mr-16" mat-icon-button [routerLink]="'/service-orders'">
                    <mat-icon>arrow_back</mat-icon>
                </button>

                <div fxLayout="column" fxLayoutAlign="start start"
                     *fuseIfOnDom [@animate]="{value:'*',params:{delay:'100ms',x:'-25px'}}">
                    <div class="h2">
                        Ordem de Serviço - {{serviceOrder.id}}
                    </div>
                    <div class="subtitle secondary-text">
                        <span>{{serviceOrder.serviceOrderStatus}}</span>
                    </div>
                </div>
            </div>
            <!-- / APP TITLE -->

        </div>
        <!-- / HEADER -->

        <!-- CONTENT CARD -->
        <div class="content-card mat-white-bg">

            <!-- CONTENT -->
            <div class="content">

                <mat-tab-group>

                    <mat-tab label="Detalhes da OS">

                        <div class="order-details tab-content p-24" fusePerfectScrollbar>

                            <div class="section pb-48">

                                <div class="pb-16" fxLayout="row" fxLayoutAlign="start center">
                                    <mat-icon class="m-0 mr-16">assignment</mat-icon>
                                    <div class="h2 secondary-text">Ordem de Serviço</div>
                                </div>
                    
                                <div class="customer">
                                    <table class="simple">
                                        <thead>
                                            <tr>
                                                <th>Número OS</th>
                                                <th>Data Abertura</th>
                                                <th>Produto</th>
                                                <th>Quantidade</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td>
                                                    <span class="text-truncate">{{serviceOrder?.id}}</span>
                                                </td>                                                
                                                <td>
                                                    <span class="text-truncate">{{serviceOrder?.lifecycle?.openDate | date : 'short'}}</span>
                                                </td>
                                                <td>
                                                    <span class="text-truncate">{{productDescription}}</span>
                                                </td>
                                                <td>
                                                    <span class="text-truncate">{{productQuantity}}</span>
                                                </td>                                  
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                            
                            <div class="section pb-48">
                    
                                <div class="pb-16" fxLayout="row" fxLayoutAlign="start center">
                                    <mat-icon class="m-0 mr-16">account_circle</mat-icon>
                                    <div class="h2 secondary-text">Cliente</div>
                                </div>
                    
                                <div class="customer">
                                    <table class="simple">
                                        <thead>
                                            <tr>
                                                <th>Nome</th>
                                                <th>Celular</th>
                                                <th>Email</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td>
                                                    <span class="email text-truncate">{{serviceOrder.relationships?.purchase.customer ? serviceOrder.relationships?.purchase.customer.name : serviceOrder.relationships?.purchase.business.name}}</span>
                                                </td>                                                
                                                <td>
                                                    <span class="email text-truncate">{{serviceOrder.relationships?.purchase.customer ? serviceOrder.relationships?.purchase.customer.mobilePhone : '-'}}</span>
                                                </td>
                                                <td>
                                                    <span class="email text-truncate">{{serviceOrder.relationships?.purchase.customer ? serviceOrder.relationships?.purchase.customer.email : '-'}}</span>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div> 

                        </div>
                    </mat-tab>

                    <mat-tab label="Rastreadores">
                        <div class="devices tab-content p-24" fusePerfectScrollbar>
                            <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" >
                                <mat-checkbox class="example-margin" (change)="skipTest($event)">Pular teste de conectividade </mat-checkbox>
                             </div> 
                             <br>
                            <div fxLayout="row" fxLayoutAlign="end center" fxLayoutGap="10px" *ngIf="canDone()">
                                <button type="button" color="primary" mat-raised-button (click)="doneServiceOrder()">Concluir Ordem de Serviço</button>
                            </div>    
                           
                               
                            
                            <div class="section pb-48">

                                <div class="pb-16" fxLayout="row" fxLayoutAlign="start center">
                                    <mat-icon class="m-0 mr-16">gps_fixed</mat-icon>
                                    <div class="h2 secondary-text">Rastreadores</div>
                                </div>

                                <form [formGroup]="generalForm" novalidate>
                                        <div class="panel">
                                            
                                            <div class="panel-content" *ngIf="canDone()">
                                                <div fxLayout="row" fxLayoutAlign="start center">
                                                  
                                                  <mat-form-field fxFlex="45">
                                                    <input matInput placeholder="Rastreadores" formControlName="device">
                                                    <mat-icon  matSuffix (click)="searchDevices()">search</mat-icon>                     
                                                  </mat-form-field>
                                                  <div fxFlex="10">
                                                        <span>&nbsp;</span>
                                                  </div>
                                                  <mat-form-field fxFlex="45">
                                                        <input matInput placeholder="SimCards" formControlName="simCard">
                                                        <mat-icon  matSuffix (click)="searchSimCards()">search</mat-icon>                     
                                                      </mat-form-field>
                                                </div>
                                            </div>
                                          </div>
                                      </form>
                    
                                    <!-- <div fxLayout="row" fxLayoutAlign="start center" *ngIf="canDone()"> -->
                                        <div class="panel" *ngIf="canDone()">
                                            <div class="panel-title">
                                                <span><mat-icon>gps_fixed</mat-icon></span>
                                                <span>&nbsp;Cadastrar Novo Rastreador</span>
                                            </div>
                                        <div class="panel-content">
                                                <div fxLayout="row" fxLayoutAlign="center" fxLayoutGap="10px" >
                                                    <form [formGroup]="deviceForm" fxFlex="100" (submit)="addDevice()" fxLayoutGap="10px" novalidate>

                                                        <mat-form-field fxFlex="15">
                                                            <mat-select placeholder="Modelo" formControlName="model">
                                                                <mat-option *ngFor="let device of deviceModelList" [value]="device.key">
                                                                    {{ device.value }}
                                                                </mat-option>
                                                            </mat-select>
                                                        </mat-form-field> 

                                                        
                                                        <mat-form-field fxFlex="20">
                                                            <input matInput 
                                                                #input maxlength="15"
                                                                placeholder="IMEI" 
                                                                formControlName="imei"
                                                                (keydown.enter)="onInputKeydown('imei', $event)">
                                                                <mat-hint position="end">{{input.value?.length || 0}}/15</mat-hint>
                                                        </mat-form-field>

                                                        <mat-form-field fxFlex="20">
                                                            <mat-select placeholder="Operadora" formControlName="operator">
                                                                <mat-option value="Claro">Claro</mat-option>
                                                                <mat-option value="TIM">TIM</mat-option>
                                                                <mat-option value="Vodafone">Vodafone</mat-option>
                                                                <mat-option value="Vivo">Vivo</mat-option>
                                                                <mat-option value="Oi">Oi</mat-option>
                                                                <mat-option value="Nextel">Nextel</mat-option>
                                                                <mat-option value="Algar">Algar</mat-option>
                                                                <mat-option value="Porto">Porto</mat-option>
                                                            </mat-select>
                                                        </mat-form-field>   

                                                        <mat-form-field fxFlex="20">
                                                            <input matInput 
                                                                    placeholder="SIM Card" 
                                                                    formControlName="simCard"
                                                                    [textMask]="{mask: simCardMask}"
                                                                    (keydown.enter)="onInputKeydown('simCard', $event)">
                                                        </mat-form-field>
                                                        
                                                        <mat-form-field fxFlex="20">
                                                            <input matInput 
                                                                placeholder="Número Linha" 
                                                                formControlName="number"
                                                                [textMask]="{mask: phoneMask}"
                                                                (keydown.enter)="onInputKeydown('number', $event)">
                                                        </mat-form-field>
                                                        
                                                        <div fxLayout="row" fxLayoutAlign="center center">
                                                            <button type="submit" mat-icon-button color="accent" matTooltip="Incluir">
                                                                <mat-icon>add_circle</mat-icon>
                                                            </button>
                                                        </div>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                <!-- </div> -->
                                <div class="panel">
                                    <div class="panel-title">
                                        <span><mat-icon>gps_fixed</mat-icon></span>
                                        <span>&nbsp;Rastreadores Cadastrados &nbsp;&nbsp;&nbsp;{{deviceList.length}} de {{productQuantity}} </span>
                                    </div>
                                    <div class="panel-content" style="max-width: 100%;">
                                   
                                        <div class="content-card mat-white-bg" style="max-width: 100%;"> 

                                            <mat-table #table [dataSource]="dataSource" [@animateStagger]="{value:'50'}" matSort matSortActive="lifecycle.testedDate" matSortDirection="asc" matSortDisableClear>
   
                                                    
                                                    <ng-container cdkColumnDef="model">
                                                        <mat-header-cell *cdkHeaderCellDef>Modelo</mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row"> 
                                                                <p class="text-truncate">{{row.model}}</p>
                                                        </mat-cell>
                                                    </ng-container>
                                                
                                                    
                                                    <ng-container cdkColumnDef="operator">
                                                        <mat-header-cell *cdkHeaderCellDef >Operadora</mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row" > 
                                                                <p class="text-truncate">{{row.operator}}</p>
                                                        </mat-cell>
                                                    </ng-container>
                                                
                                                   
                                                    <ng-container cdkColumnDef="imei">
                                                        <mat-header-cell *cdkHeaderCellDef >IMEI</mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row" >
                                                            <p class="text-truncate">{{row.imei}}</p>
                                                        </mat-cell>
                                                    </ng-container>
                                                    
                                                
                                                    <ng-container cdkColumnDef="simCard">
                                                        <mat-header-cell *cdkHeaderCellDef >SIM CARD</mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row" >
                                                            <p class="text-truncate">{{row.simCard}}</p>
                                                        </mat-cell>
                                                    </ng-container>
                                                
                                                    
                                                    <ng-container cdkColumnDef="number">
                                                        <mat-header-cell *cdkHeaderCellDef >Número da Linha</mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row" >
                                                            <p class="text-truncate">{{row.number}}</p>
                                                        </mat-cell>
                                                    </ng-container>

                                                    
                                                     <ng-container cdkColumnDef="status">
                                                        <mat-header-cell *cdkHeaderCellDef >Status</mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row" >
                                                            <p class="text-truncate" [hidden]="row.status == 'TESTED' ? true : false" style=" color: crimson ">{{deviceActivityToString(row)}}</p>
                                                            <p class="text-truncate" [hidden]="row.status != 'TESTED' ? true : false" style=" color:blue ">{{deviceActivityToString(row)}}</p>
                                                        </mat-cell>
                                                    </ng-container>

                                                   
                                                    <ng-container cdkColumnDef="reload">
                                                        <mat-header-cell *cdkHeaderCellDef fxFlex="48px" ></mat-header-cell>
                                                        <mat-cell *cdkCellDef="let row" fxFlex="48px"  >
                                                            <button mat-icon-button class="sidebar-toggle" 
                                                                    (click)="updateStatusDevice(row)">
                                                                <mat-icon *ngIf="canDone()" class="secondary-text">autorenew</mat-icon>
                                                            </button>
                                                        </mat-cell>
                                                    </ng-container>

                                                     
                                                     <ng-container cdkColumnDef="delete">
                                                            <mat-header-cell *cdkHeaderCellDef fxFlex="48px" ></mat-header-cell>
                                                            <mat-cell *cdkCellDef="let row" fxFlex="48px"  >
                                                                <button mat-icon-button class="sidebar-toggle" 
                                                                        (click)="deleteDevice(row)">
                                                                    <mat-icon *ngIf="canDone()" class="secondary-text">delete</mat-icon>
                                                                </button>
                                                            </mat-cell>
                                                        </ng-container>
                                                
                                                    <mat-header-row *cdkHeaderRowDef="displayedColumns"></mat-header-row>
                                                    <mat-row *cdkRowDef="let row; columns: displayedColumns;"
                                                             [ngClass]="{'mat-accent-50-bg':row == selected}"
                                                             matRipple [@animate]="{value:'*',params:{y:'100%'}}">
                                                    </mat-row>
                                                </mat-table>

                                                <mat-paginator #paginator [hidden]="!isDone"
                                                [length]="contentLength" 
                                                [pageSize]="pageSize" 
                                                [pageSizeOptions]="[10, 50, 100]">
                                              </mat-paginator>
                                    
                                        </div>
                                    </div>
                                </div>

                            </div>

                        </div>
                    </mat-tab>

                </mat-tab-group>

            </div>
            <!-- / CONTENT -->

        </div>
        <!-- / CONTENT CARD -->

    </div>
    <!-- / CENTER -->
</div>



<div id="order" class="page-layout carded fullwidth" fusePerfectScrollbar>

    <!-- TOP BACKGROUND -->
    <div class="top-bg {{secondColorBrand}}"></div>
    <!-- / TOP BACKGROUND -->

    <!-- CENTER -->
    <div class="center">

        <!-- HEADER -->
        <div class="header white-fg"
              fxLayout="row" fxLayoutAlign="space-between center">

            <!-- APP TITLE -->
            <div fxLayout="row" fxLayoutAlign="start center">

                <button class="mr-16" mat-icon-button [routerLink]="'/service-orders'">
                    <mat-icon>arrow_back</mat-icon>
                </button>

                <div fxLayout="column" fxLayoutAlign="start start"
                      *fuseIfOnDom [@animate]="{value:'*',params:{delay:'100ms',x:'-25px'}}">
                    <div class="h2">
                        Ordem de Serviço - {{serviceOrder.id}}
                    </div>
                    <div class="subtitle secondary-text">
                        <span>{{serviceOrder.serviceOrderStatus}}</span>
                    </div>
                </div>
            </div>
            <!-- / APP TITLE -->

        </div>
        <!-- / HEADER -->

        <!-- CONTENT CARD -->
        <div class="content-card mat-white-bg">

            <!-- CONTENT -->
            <div class="content" fxFlex="100">

              <mat-tab-group>
                <mat-tab label="Ordem de Serviço">
                    <div class="tab-content p-24" fusePerfectScrollbar>
                    </div>
                </mat-tab>

                <mat-tab label="Montagem do Kit">
                  <div class="tab-content p-24" fusePerfectScrollbar>                

                  </div>
                </mat-tab>

              </mat-tab-group>

            </div>
            <!-- / CONTENT -->

        </div>
        <!-- / CONTENT CARD -->

    </div>
    <!-- / CENTER -->
</div>